<?php

namespace App;

use Murdej\ActiveRow\TableInfo;

class BaseModel extends \Murdej\ActiveRow\BaseEntity
{
	static protected $defaultOrder = null;

	public static function findBy($cond, $applyOrder = true, $applyDeleted = true)
	{
		// $sel = self::repository()->newSelect();
		$sel = parent::findBy($cond);
		if ($applyOrder && self::$defaultOrder) 
		{
			if (is_array($this->defaultOrder)) 
			{
				foreach(array_reverse($this->defaultOrder) as $col)
					$sel->order($col);
			} 
			else 
			{
				$sel->order($this->defaultOrder);
			}
		}
		if ($applyDeleted && self::getDBInfo()->existsCol('deleted')) 
		{
			$sel->where(self::getDBInfo()->tableName.'.deleted', false);
		}
		
		return $sel;
	}

	public static function findAll($db = null)
	{
		return self::findBy([]);
	}
	
	public static function getDBInfo()
	{
		return TableInfo::get(get_called_class()); //->existsCol('deleted'); // $this->$this->_dbEntity->getDbInfo()->existsCol('deleted');
	} 
}

