<?php
// error_reporting(E_ERROR | E_WARNING | E_PARSE | E_DEPRECATED);
error_reporting(~E_USER_DEPRECATED);

require __DIR__ . '/../vendor/autoload.php';

$configurator = new Nette\Configurator;

//$configurator->setDebugMode('23.75.345.200'); // enable for your remote IP
$configurator->setDebugMode(true);
$configurator->enableDebugger(__DIR__ . '/../log');

$configurator->setTimeZone('Europe/Prague');
$configurator->setTempDirectory(__DIR__ . '/../temp');
$parameters = [];
foreach(['databaseHost', 'databaseName', 'databaseUser', 'databasePass', 'solarbotUrl', 'solarbotRefresh'] as $k)
	$parameters[$k] = $_ENV[$k] ?? $_SERVER[$k] ?? null;

$configurator->addParameters($parameters);

$_robotloader = $configurator->createRobotLoader();
$_robotloader
	->addDirectory(__DIR__)
	->addDirectory(__DIR__."/../libs")
	->register();

$configurator->addConfig(__DIR__ . '/config/config.neon');
$configurator->addConfig(__DIR__ . '/config/config.local.neon');

$container = $configurator->createContainer();

error_reporting(E_ERROR | E_WARNING | E_PARSE);

Tracy\Debugger::$maxDepth = 10;
Tracy\Debugger::$maxLen = 10000;

Murdej\ActiveRow\DBRepository::$databaseCreator = function($tableInfo) use($container)
{
	return $container->getService("database");
};


// Texy

$container->addService('texy', function($container) {
    return new Nette\Database\Connection(
        $container->parameters['dsn'],
        $container->parameters['user'],
        $container->parameters['password']
    );
});

function barDump($v, $c = null)
{
	Tracy\Debugger::barDump($v, $c);
}

define('LIBS_DIR', __DIR__ . '/../libs');
define('APP_DIR', __DIR__);
include __DIR__ . '/loadExtensions.php';

return $container;
