<?php

namespace App;

use Murdej\Duration;
use Nette\Application\UI;
use Nette\Application\UI\Form;

class AdvSumFormChange extends DefaultForm {

	/** @var array */
	public $onChange;

	public function __construct(IContainer $parent = NULL, $name = NULL) {
		parent::__construct($parent, $name);
		$this->addHidden('utFrom');
		$this->addHidden('utTo');
		$this->onSuccess[] = $this->formSave;
	}
	public function loadData($data, $utFrom, $utTo) {
		$defaults = array('utFrom' => $utFrom, 'utTo' => $utTo);
	
		foreach($data as $item) {
			$this->addHidden("dcc_".$item->productId);
			$t = "počet smazaných " . $item->product->name;
			$this->addText("dnc_".$item->productId, $t)
				->setRequired('Zadejte ' . $t)
				->addRule(Form::INTEGER, $t . ' musí být číslo')
				->addRule(Form::RANGE, $t . ' musí být od %d do %d', array(0, $item->countS));

			$defaults["dcc_".$item->productId] = $item->countD;
			$defaults["dnc_".$item->productId] = $item->countD;
		}
		$this->addSubmit('btnSave', 'Uložit změny'); // ->onClick[] = $this->formSave;

		$this->setDefaults(
			$defaults
		);		
	}
	public function formSave($form) {
		// $values = $button->form->values;
		$values = $form->values;
		$dc = array();
		foreach($values as $k => $v) {
			$tmp = explode('_', $k);
			if (count($tmp) == 2) {
				list($t, $id) = $tmp;
				$dc[$id][$t] = $v;
			}
		}
		$res = array();
		foreach($dc as $k => $v) {
			if ($v["dcc"] != $v["dnc"]) {
				// $this->presenter->flashmessage("$k : $v[dcc] != $v[dnc]");
				$res[$k] = $v["dcc"] - $v["dnc"];
			}
		}
		
		$this->onChange($res);
	}	
}
