<?php

namespace App;

use Nette\Utils\Json;

/**
@dbTable
@property string $key
@property string $content
@property string $contentType
**/
class Config extends BaseModel 
{ 
	public static function getVal(string $key)
	{
		$conf = self::getBy(["key" => $key]);
		return $conf ? $conf->getValue() : null;
	}

	public static function setVal(string $key, $value, $contentType = null)
	{
		$conf = self::getBy(["key" => $key]);
		if (!$conf) 
		{
			$conf = new Config();
			$conf->key = $key;
		}
		if ($contentType == null)
		{
			if (is_array($value) || is_object($value)) $contentType = "json";
			else if (is_integer($value)) $contentType = "int";
			else $contentType = "string";
		}
		switch($contentType)
		{
			case "json":
			case "jsona":
				$value = Json::encode($value, Json::PRETTY);
				break;
			default:
				break;
		}

		$conf->content = $value;
		$conf->save();
	}

	public function getValue()
	{
		$v = $this->content;
		switch($this->contentType)
		{
			case "string": break;
			case "int": 
				$v = (int)$v;
				break;
			case "jsona":
				$v = Json::decode($this->content, Json::FORCE_ARRAY);
				break;
			case "json":
				$v = Json::decode($this->content);
				break;
		}
	}


}