# Aplikace kasa <br /><small>návod k použití a nastavení</small>

## Permanentka 

Permanentky umožňuje následující:

- Nabití a čerpání kreditu
- Zakoupení a čerpání balíčku produktů
- Nastavení zvýhodněných/nulových cen
- Omezení platnosti jak dlouho je permanentka platná

Toto je možné i kombinovat.

### Nastavení permanentky

Nastavení se provádí v administraci v části  **Permanentky**.

#### Část základních údajů:

![Část základních údajů](./images/permanentka-admin-edit.png)

 - **Název** - název permanentky
 - **Kredit** - přednabitý kredit
 - **Doba platnosti** - doba platnosti dokud je pernamentka platná. Doba se zadává jako počet a jednoka (r - rok, m - měsíc, d - den). Příklad: `1r` - 1 rok, `14d` - 14 dnů nebo kombinací
 - **Kredit do mínusu** - umožní aby se dal kredit čerpat na dluh.
 - **Dobíjitelný kredit** - umožní dobíjení kreditu hotovostí

#### Část produktů:

![](./images/permanentka-admin-products.png)

Pro každý produkt v nabídce můžete nastavit následující:

 - **Kusů** - počet kusů který je v permanentce k dispozici.
 - **Z kreditu** -  označí že tento produkt je možné nakoupit za kredit na permanentce
 - **/ v ceně** - pokud je vyplněno bude nákup produktu z kreditu za zadanou cenu, pokud ne bude za běžnou cenu
 - **Hotově** - zvýhodněná cena pro zákazníky s touto permanentkou

### Přidání do prodeje

Kliknutím na **Do prodeje** ve sloupci **v prodeji** se vytvoří položka v produktech aby bylo možné permanentku prodat/založit zákazníkovy. 

Druhá možnost je vybrat permanentku při zakládání produktu.

### Jak na ... - několik příkladů:

#### Kredit

Zákazník si dobíjí kredit a z kreditu hradí útratu:

 - **Dobíjitelný kredit** : Ano
 - Zaklikat u všech produktů **Z kreditu**

#### 20 vstupů

20 vstupů, bez omezení doby kdy se využijí.

 - U produktu **Jednorázový vstup** nastavit **Kusů** na 20

#### Neomezený počet vstupů na měsíc

 - U permanentky **Doba platnosti** nastavit na `1m`
 - U produktu **Jednorázový vstup** nastavit **v ceně** a **Hotově** na `0`

#### Sleva na produkty některé zákazníky

- U produktů se slevou nastavit **v ceně** a **Hotově** sníženou cenu.

### Použití permanentky

Zakoupené (aktivní i neaktivní) permanentky aktuálního zákazníka se zobrazují v pravém panelu. Pokud má omezenou platnost nebo počet produktů, zobrazuje se zbývající doba, zbývající kredit nebo počet. Kliknutím se zobrazí detail permanentky.

![](./images/permanentka-detail.png)

#### Zakoupení permanentky

Permanentka se kupuje stejně jako jiné produkty. Použití permanentky je možné až po uzavření účtu kde je zakoupená.

#### Aktivace permanentky

V případě že je platnost permanentky neomezená aktivuje se automaticky. Pokud je časově omezená aktivuje se v detailu permanentky tlačítkem aktivovat:

![](./images/permanentka-aktivace.png)

#### Využívání produktů z permanentky

V případě permanentky s počtem produktů je při nákupu na výběr jestli produkt zaplatit hotově nebo z permanentky:

![](./images/permanentka-nakup.png)

U permanentky kde je nastavená jiná cena (napřklad neomezený počet vstupů na určitý čas) se zobrazuje a účtuje snížená/nulová cena:

![](./images/permanentka-nakup-0.png)

Pokud je možné využít kredit  je při nákupu na výběr jestli produkt zaplatit hotově nebo z kreditu:

![](./images/permanentka-nakup-kredit.png)

#### Dobití kreditu

Kredit se dobíjí v detailu permanentky:

![](./images/permanentka-dobiti-kreditu-1.png)

Kredit je použitelný po uzavření účtu ve kterém se kredit dobíjí.

