<?php

namespace Murdej\Forms;

use Nette\Forms\Form;
use Nette\Forms\Container as FormContainer;
use Nette\Utils\Html;

/**
* Selectize input control.
*
* @author     Murdej
* @package    Murdej\Nette\Forms
*/
class CKE extends \Nette\Forms\Controls\TextArea
{

	public function __construct($label)
	{
		parent::__construct($label);
	}

	protected $value = null;

	public $readonly = false;

	/** @var string|null */
	public $imageUploadUrl = null;
	
	/**
	* Returns control's value.
	* @return mixed 
	*/
	public function getValue()
	{
		return $this->value;
	}
	
	/**
	* Sets control's value.
	* @param  string
	* @return void
	*/
	public function setValue($value)
	{
		$this->value = $value;
	}

	public function loadHttpData(): void
	{
		$this->value = $this->getHttpData(Form::DATA_LINE);
	}

	public function getControl(): Html
	{
		$control = parent::getControl();
		$control->addText($this->value);
		return $control->addAttributes([
			'mu-widget' => 'CKE',
			'mu-params' => json_encode([
				'imageUploadUrl' => $this->imageUploadUrl
			])
		]);
	}


	static function register() 
	{
		FormContainer::extensionMethod('addCKE', array(__CLASS__, 'addCKE')); // v PHP 5.3
	}

	static function addCKE($_this, $name, $label)
	{
		return $_this[$name] = new CKE($label);
	}
}
