<?php

namespace Murdej\Forms;

use Nette\Forms\Form;
use Nette\Forms\Container as FormContainer;

/**
* Selectize input control.
*
* @author     Murdej
* @package    Nette\Extras
*/
class NumberInput extends \Nette\Forms\Controls\BaseControl
{

	public function __construct($label, $isDecimal)
	{
		parent::__construct($label);
		$this->isDecimal = $isDecimal;
		$this->setRequired(false);/*
			->addCondition(Form::FILLED)
				->addRule(
					$this->isDecimal ? Form::FLOAT : Form::INTEGER, 
					$this->isDecimal ? "Zadejte $label destinným číslem" : "Zadejte $label celým číslem"
				); */
	}

	protected $value = null;

	public $isDecimal = true;

	public $decimalPoint = ',';

	public $decimalPlaces = null;

	public $readonly = false;

	/**
	* Returns control's value.
	* @return mixed 
	*/
	public function getValue()
	{
		return $this->value;
	}


	/**
	* Sets control's value.
	* @param  string
	* @return void
	*/
	public function setValue($value)
	{
		$this->value = $value;
	}

	public function loadHttpData(): void
	{
		$rawData = trim($this->getHttpData(Form::DATA_LINE));
		$this->value = $rawData
			? (float)str_replace([$this->decimalPoint, ' '], ['.', ''], $rawData)
			: null;
	}

	protected function getFormated()
	{
		return str_replace('.', ',', $this->value);
	}

	public function getControl()
	{
		$el = clone $this->control;
		return $el->addAttributes([
			'id' => $this->getHtmlId(),
			'type' => /*'text', */ 'number',
			'name' => $this->getHtmlName(),
			'class' => array('form-control number'),
			'value' => $this->value, // getFormated(),
			'readonly' => $this->readonly,
			'step' => "any",
			'lang' => 'cz'
		]);
	}


	static function register() 
	{
		FormContainer::extensionMethod('addNumber', array(__CLASS__, 'addNumber')); // v PHP 5.3
	}

	static function addNumber($_this, $name, $label, $isDecimal = false)
	{
		return $_this[$name] = new NumberInput($label, $isDecimal);
	}
}
